<!DOCTYPE html>
<html>
	<body>
		<p>Click the button to solve 1 question of satck</p>
		<button onclick="getNthElement()">stack</button>
		<p id="demo"></p>

		<script>
			function getNthElement() {
				class Stack {
				// Array is used to implement stack
					constructor() {
						this.items = [];
					}
				
					// push function
					push(element) {
						// push element into the items
						this.items.push(element);
					}
				
					// pop
					pop() {
						// function return top most element in the stack and removes it from the stack Underflow if stack is empty
						if(this.items.length == 0)
							return "Underflow";
						return this.items.pop();
					}
				
					// peek function
					peek() {
						// return the top most element from the stack but does'nt delete it.
						return this.items[this.items.length - 1];
					}
					
					// isEmpty function
					isEmpty() {
						// return true if stack is empty
						return this.items.length == 0;
					}

                    //size of stack
                    size() {
                        return this.items.length;
                    }

					// printStack function
					printStack() {
						var str = "";
						for (var i = 0; i < this.items.length; i++)
							str += this.items[i] + " ";
						return str;
					}
				}

                //delete mid element of stack
                function deleteMid(stack, n, curr) {
  
                    //If stack is empty or all items are traversed 
                    if (stack.isEmpty() || curr == n)
                        return
                    //Remove current item 
                    var x = stack.peek() 
                    stack.pop() 
                        
                    //Remove other items 
                    deleteMid(stack, n, curr+1) 
                        
                    //Put all items back except middle 
                    if (curr != Math.floor(n/2))
                        stack.push(x) 
                }
				
				// creating object for stack class
				var stack = new Stack();
				// testing isEmpty and pop on an empty stack returns false
				console.log(stack.isEmpty());
				// returns Underflow
				console.log(stack.pop());
				// Adding element to the stack
				stack.push(10);
				stack.push(20);
				stack.push(30);
				// Printing the stack element prints [10, 20, 30]
				console.log(stack.printStack());
				// returns 30
				console.log(stack.peek());
				// returns 30 and remove it from stack
				console.log(stack.pop());
				// returns [10, 20]
				console.log(stack.printStack());
                stack.push(70);
				stack.push(80);
				stack.push(90);
                console.log(stack.printStack());
                deleteMid(stack, stack.size(), 0);
                console.log(stack.printStack());


		}
		</script>

	</body>
</html>